(import (r7rs))

(define-library (srfi 180)
  (import (scheme base)
          (scheme inexact)
          (scheme case-lambda)
          (scheme char)
          (scheme write)
          (srfi 180 helpers)
          (srfi 145)
          (only (srfi 60) arithmetic-shift bitwise-ior))
  (export json-number-of-character-limit
          json-nesting-depth-limit
          json-null?
          json-error?
          json-error-reason
          json-fold
          json-generator
          json-read
          json-lines-read
          json-sequence-read
          json-accumulator
          json-write)
  (include "srfi.180-impl.scm"))
