(import (r7rs))

(define-library (srfi 180 helpers)

  (export valid-number?)

  (import (scheme base)
          (chicken irregex))

  (begin

    (define (valid-number? string)
      (irregex-match?
       `(seq
         (? #\-)
         (or #\0 (seq (- numeric #\0)
                      (* numeric)))
         (? (seq #\. (+ numeric)))
         (? (seq (or #\e #\E)
                 (? (or #\- #\+))
                 (+ numeric))))
       string))))
